﻿using System;
using System.Data;
using System.Data.OleDb;
using System.Windows.Forms;

namespace CRUDAccess
{
    public partial class Form1 : Form
    {

        private string ConnectionString = string.Format(@"Provider=Microsoft.ACE.OLEDB.12.0;Data Source={0}\sampleDB.accdb", 
                                                        Application.StartupPath.ToString());

public void SelectAllRecords()
{

    OleDbConnection OleDbConnection1 = new OleDbConnection(ConnectionString);
    OleDbCommand OleDbCommand1 = new OleDbCommand();
    OleDbCommand1.CommandType = CommandType.Text;
    OleDbCommand1.CommandText = "SELECT * FROM Person";
    OleDbCommand1.Connection = OleDbConnection1;
    OleDbDataAdapter adapter = new OleDbDataAdapter(OleDbCommand1);
    DataSet DataSet1 = new DataSet();
    adapter.Fill(DataSet1, "Person");
    dataGridView1.DataSource = DataSet1.Tables["Person"];
    dataGridView1.Columns[0].HeaderText = "شناسه";
    dataGridView1.Columns[1].HeaderText = "نام";
    dataGridView1.Columns[2].HeaderText = "نام خانوادگی";
    dataGridView1.Columns[3].HeaderText = "سن";
}

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            this.SelectAllRecords();
        }

private void dataGridView1_CellEnter(object sender, DataGridViewCellEventArgs e)
{
    if (dataGridView1.Rows.Count > 0)
    {
        this.txtName.Text = dataGridView1.Rows[e.RowIndex].Cells[1].Value.ToString();
        this.txtFamily.Text = dataGridView1.Rows[e.RowIndex].Cells[2].Value.ToString();
        this.txtAge.Text = dataGridView1.Rows[e.RowIndex].Cells[3].Value.ToString();
    }
}

private void Insert_Click(object sender, EventArgs e)
{
    OleDbConnection OleDbConnection1 = new OleDbConnection(this.ConnectionString);
    OleDbCommand OleDbCommand1 = new OleDbCommand();
    OleDbCommand1.Connection = OleDbConnection1;
    OleDbCommand1.CommandType = CommandType.Text;
    OleDbCommand1.CommandText = "INSERT INTO Person(Name, Family, Age) VALUES (@Name,@Famlily,@Age)";
    OleDbCommand1.Parameters.AddWithValue("@Name", this.txtName.Text);
    OleDbCommand1.Parameters.AddWithValue("@Family", this.txtFamily.Text);
    OleDbCommand1.Parameters.AddWithValue("@Age", this.txtAge.Text);
    OleDbConnection1.Open();
    int result = OleDbCommand1.ExecuteNonQuery();
    OleDbConnection1.Close();
    if (result > 0)
    {
        MessageBox.Show("Insert OK");
        this.SelectAllRecords();
    }
    else
    {
        MessageBox.Show("Error In Insert");
    }
}

private void Update_Click(object sender, EventArgs e)
{
    if (this.dataGridView1.Rows.Count > 0)
    {
        string currentPersonId = this.dataGridView1.CurrentRow.Cells[0].Value.ToString();
        OleDbConnection OleDbConnection1 = new OleDbConnection(this.ConnectionString);
        OleDbCommand OleDbCommand1 = new OleDbCommand();
        OleDbCommand1.Connection = OleDbConnection1;
        OleDbCommand1.Connection = OleDbConnection1;
        OleDbCommand1.CommandType = CommandType.Text;
        OleDbCommand1.CommandText = "UPDATE Person SET Name=@Name,Family=@Family,Age=@Age WHERE Id = @Id";
        OleDbCommand1.Parameters.AddWithValue("@Name",this.txtName.Text);
        OleDbCommand1.Parameters.AddWithValue("@Family",this.txtFamily.Text);
        OleDbCommand1.Parameters.AddWithValue("@Age",this.txtAge.Text);
        OleDbCommand1.Parameters.AddWithValue("@Id",currentPersonId);
        OleDbConnection1.Open();
        int result = OleDbCommand1.ExecuteNonQuery();
        OleDbConnection1.Close();

        if (result > 0)
        {
            MessageBox.Show("Update OK");
            SelectAllRecords();
        }
        else
        {
            MessageBox.Show("Update Error");
        }
    }
}

private void Delete_Click(object sender, EventArgs e)
{
    if (this.dataGridView1.Rows.Count > 0)
    {
        string currentPersonId = this.dataGridView1.CurrentRow.Cells[0].Value.ToString();
        OleDbConnection OleDbConnection1 = new OleDbConnection(this.ConnectionString);
        OleDbCommand OleDbCommand1 = new OleDbCommand();
        OleDbCommand1.Connection = OleDbConnection1;
        OleDbCommand1.CommandType = CommandType.Text;
        OleDbCommand1.CommandText = "DELETE FROM Person WHERE ID=" + currentPersonId;
        OleDbConnection1.Open();
        int result = OleDbCommand1.ExecuteNonQuery();
        OleDbConnection1.Close();
        if (result > 0)
        {
            MessageBox.Show("Delete OK");
            SelectAllRecords();
        }
        else
        {
            MessageBox.Show("Delete Error");
        }
    }
}

private void txtSearch_TextChanged(object sender, EventArgs e)
{
    string query = "SELECT * FROM Person WHERE Name LIKE '%" + 
                    this.txtSearch.Text + "%' OR " +
                    "Family LIKE '%" + this.txtSearch.Text + "%'";

    OleDbConnection OleDbConnection1 = new OleDbConnection(ConnectionString);
    OleDbCommand OleDbCommand1 = new OleDbCommand();
    OleDbCommand1.CommandText = query;
    OleDbCommand1.Connection = OleDbConnection1;
    OleDbDataAdapter adapter = new OleDbDataAdapter(OleDbCommand1);
    DataTable result = new DataTable();
    adapter.Fill(result);
    this.dataGridView1.DataSource = result;
    dataGridView1.Columns[0].HeaderText = "شناسه";
    dataGridView1.Columns[1].HeaderText = "نام";
    dataGridView1.Columns[2].HeaderText = "نام خانوادگی";
    dataGridView1.Columns[3].HeaderText = "سن";
}
    }
}
